Skip to content

Segment

POST
/api/data/namespaces/{namespace}/segments/graph
curl --request POST \
--url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/data/namespaces/example/segments/graph \
--header 'Authorization: <Authorization>' \
--header 'Content-Type: application/json' \
--data '{ "end_time": "example", "field_selector": { "edge_metric_type": [ "METRIC_NONE" ], "node_metric_type": [ "METRIC_NONE" ] }, "group_by": [ "SEGMENT_LABEL_NONE" ], "label_filter": [ { "label": "SEGMENT_LABEL_NONE", "op": "EQ", "value": "example" } ], "namespace": "example", "start_time": "example", "step": "example" }'

Request to GET different network segments with given metrics . This will give metric data for all segments including intra segment metrics.

Examples of this operation.

namespace
required
string

Namespace This request is supported only in system namespace.

Media typeapplication/json
Segments Request

Request to specify filters, group by, metric selectors etc for segments.

object
end_time
end_time

End time of metric collection from which data will be considered to build graph. Format: unix_timestamp|RFC 3339

Optional: If not specified, then the end_time will be evaluated to start_time+10m If start_time is not specified, then the end_time will be evaluated to

string
<= 1024 characters
field_selector
object
edge_metric_type
Edge

Field Selector for edge.

Array<string>
Allowed values: METRIC_NONE IN_BYTES OUT_BYTES NODE_ATTACHMENTS NODE_SITES
node_metric_type
Node

Field Selector for node.

Array<string>
Allowed values: METRIC_NONE IN_BYTES OUT_BYTES NODE_ATTACHMENTS NODE_SITES
group_by
group_by

Aggregate data by given group by.

Optional: If not specified, then the data is aggregated/grouped by segment_name.

Array<string>
Allowed values: SEGMENT_LABEL_NONE SEGMENT_NAME
label_filter
label_filter

List of label filter expressions of the form “label key” QueryOp “value”. Response will only contain data that matches all the conditions specified in the label_filter.

Optional: If not specified, segment data for all segments will be returned in the response.

Array<object>

Label Filter.

Filters that will use segment labels to filter out timeseries.

object
label
string
default: SEGMENT_LABEL_NONE
Allowed values: SEGMENT_LABEL_NONE SEGMENT_NAME
op
string
default: EQ
Allowed values: EQ NEQ
value
Value

Value of the label.

string
>= 3 characters <= 1024 characters
namespace
Namespace

This request is supported only in system namespace.

string
>= 6 characters <= 1024 characters
start_time
start_time

Start time of metric collection from which data will be considered to build response. Format: unix_timestamp|RFC 3339

Optional: If not specified, then the start_time will be evaluated to end_time-10m If end_time is not specified, then the start_time will be evaluated to -10m.

string
<= 1024 characters
step
step

Step is the resolution width, which determines the number of the data points [x-axis (time)] to be returned in the response. The timestamps in the response will be t1=start_time, t2=t1+step, … Tn=tn-1+step, where tn <= end_time. Format: [0-9][smhd], where s - seconds, m - minutes, h - hours, d - days

Optional: If not specified, then step size is evaluated to <end_time - start_time>

string
<= 1024 characters

A successful response.

Media typeapplication/json
Segment Response

Response for all segments. Metric data for all segments for each metric type specified in the request.

object
edges
Segments

Data for different metric types for all segments.

Array<object>

Edge Data.

Data for each segment edge in the segments response.

object
data

Metric data for the given metric.

Array<object>

Node Metric Data.

Metric Data for each metric type in the segments node.

object
type
string
default: METRIC_NONE
Allowed values: METRIC_NONE IN_BYTES OUT_BYTES NODE_ATTACHMENTS NODE_SITES
unit
string
default: UNIT_MILLISECONDS
Allowed values: UNIT_MILLISECONDS UNIT_SECONDS UNIT_MINUTES UNIT_HOURS UNIT_DAYS UNIT_BYTES UNIT_KBYTES UNIT_MBYTES UNIT_GBYTES UNIT_TBYTES UNIT_KIBIBYTES UNIT_MIBIBYTES UNIT_GIBIBYTES UNIT_TEBIBYTES UNIT_BITS_PER_SECOND UNIT_BYTES_PER_SECOND UNIT_KBITS_PER_SECOND UNIT_KBYTES_PER_SECOND UNIT_MBITS_PER_SECOND UNIT_MBYTES_PER_SECOND UNIT_CONNECTIONS_PER_SECOND UNIT_ERRORS_PER_SECOND UNIT_PACKETS_PER_SECOND UNIT_REQUESTS_PER_SECOND UNIT_PACKETS UNIT_PERCENTAGE UNIT_COUNT
value
Value

Metric value.

Array<object>
>= 3 characters <= 15 characters
Metric Value

Metric data contains timestamp and the value.

object
timestamp
Timestamp

Timestamp

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
dst_labels
x-displayName: "DstLabels" Dst Labels contains the name/value pair for dst in an edge. "name" is the label defined in Labels

“name” is the label defined in Labels.

object
src_labels
x-displayName: "SrcLabels" Src Labels contains the name/value pair for src in an edge. "name" is the label defined in Labels

“name” is the label defined in Labels.

object
nodes
Segments

Data for different metric types for all segments.

Array<object>

Node Data.

Data for each segment node in the segments response.

object
connected_segments

Number of connected segments for a given segment.

string format: uint64
<= 1024 characters
data

Metric data for the given metric.

Array<object>

Node Metric Data.

Metric Data for each metric type in the segments node.

object
type
string
default: METRIC_NONE
Allowed values: METRIC_NONE IN_BYTES OUT_BYTES NODE_ATTACHMENTS NODE_SITES
unit
string
default: UNIT_MILLISECONDS
Allowed values: UNIT_MILLISECONDS UNIT_SECONDS UNIT_MINUTES UNIT_HOURS UNIT_DAYS UNIT_BYTES UNIT_KBYTES UNIT_MBYTES UNIT_GBYTES UNIT_TBYTES UNIT_KIBIBYTES UNIT_MIBIBYTES UNIT_GIBIBYTES UNIT_TEBIBYTES UNIT_BITS_PER_SECOND UNIT_BYTES_PER_SECOND UNIT_KBITS_PER_SECOND UNIT_KBYTES_PER_SECOND UNIT_MBITS_PER_SECOND UNIT_MBYTES_PER_SECOND UNIT_CONNECTIONS_PER_SECOND UNIT_ERRORS_PER_SECOND UNIT_PACKETS_PER_SECOND UNIT_REQUESTS_PER_SECOND UNIT_PACKETS UNIT_PERCENTAGE UNIT_COUNT
value
Value

Metric value.

Array<object>
>= 3 characters <= 15 characters
Metric Value

Metric data contains timestamp and the value.

object
timestamp
Timestamp

Timestamp

number format: double
trend_value
object
description
Description

Description of the method used to calculate trend.

string
>= 21 characters <= 1024 characters
previous_value
Previous Value

Configuration parameter for previous value

string
<= 1024 characters
sentiment
string
default: TREND_SENTIMENT_NONE
Allowed values: TREND_SENTIMENT_NONE TREND_SENTIMENT_POSITIVE TREND_SENTIMENT_NEGATIVE
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
value
Value

Configuration parameter for value

string
>= 3 characters <= 1024 characters
labels
x-displayName: "Labels" Labels contains the name/value pair. "name" is the label defined in Labels

“name” is the label defined in Labels.

object
step
step

Actual step size used in the response. It could be higher than the requested step due to metric rollups and the query duration. Format: [0-9][smhd], where s - seconds, m - minutes, h - hours, d - days.

string
<= 1024 characters
Example
{
"edges": [
{
"data": [
{
"type": "METRIC_NONE",
"unit": "UNIT_MILLISECONDS",
"value": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
]
}
]
}
],
"nodes": [
{
"data": [
{
"type": "METRIC_NONE",
"unit": "UNIT_MILLISECONDS",
"value": [
{
"trend_value": {
"sentiment": "TREND_SENTIMENT_NONE"
}
}
]
}
]
}
]
}

Returned when operation is not authorized.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when there is no permission to access resource.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when resource is not found.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation on resource is conflicting with current value.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation has been rejected as it is happening too frequently.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server encountered an error in processing API.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when service is unavailable temporarily.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server timed out processing request.

Media typeapplication/json
string format: string
Examplegenerated
example